// TsTable.cpp: TSe[ubp[NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TsTable.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// CPsiTableNX̍\z/
//////////////////////////////////////////////////////////////////////

CPsiTable::CPsiTable()
{
	Reset();
}

CPsiTable::CPsiTable(const CPsiTable &Operand)
{
	*this = Operand;
}

CPsiTable & CPsiTable::operator = (const CPsiTable &Operand)
{
	m_TableArray = Operand.m_TableArray;

	return *this;
}

const bool CPsiTable::StoreSection(const CPsiSection *pSection, bool *pbUpdate)
{
	bool bUpdate = false;

	// ZNṼTCY`FbN
	if(!pSection->GetSize()){
		if(pbUpdate)*pbUpdate = bUpdate;
		return false;
		}

	// JglNXgCWP[^`FbN({͕ʃoNɒ߂ׂH)
	if(!pSection->IsCurrentNext()){
		if(pbUpdate)*pbUpdate = bUpdate;
		return true;
		}

	// e[uIDg
	DWORD dwIndex;

	for(dwIndex = 0 ; dwIndex < m_TableArray.size() ; dwIndex++){
		if(m_TableArray[dwIndex].wTableIdExtension == pSection->GetTableIdExtension())break;
		}

	if(dwIndex >= m_TableArray.size()){
		// e[uIDgȂAe[uǉ
		m_TableArray.resize(dwIndex + 1);
		m_TableArray[dwIndex].wTableIdExtension = pSection->GetTableIdExtension();
		m_TableArray[dwIndex].wSectionNum = (WORD)pSection->GetLastSectionNumber() + 1;
		m_TableArray[dwIndex].byVersionNo = pSection->GetVersionNo();
		m_TableArray[dwIndex].SectionArray.resize(m_TableArray[dwIndex].wSectionNum);
		bUpdate = true;
		}
	else if(m_TableArray[dwIndex].byVersionNo != pSection->GetVersionNo()){
		// o[WsvAe[uXVꂽ
		m_TableArray[dwIndex].wSectionNum = (WORD)pSection->GetLastSectionNumber() + 1;
		m_TableArray[dwIndex].byVersionNo = pSection->GetVersionNo();
		m_TableArray[dwIndex].SectionArray.clear();
		m_TableArray[dwIndex].SectionArray.resize(m_TableArray[dwIndex].wSectionNum);
		bUpdate = true;
		}
	else if(m_TableArray[dwIndex].wSectionNum != ((WORD)pSection->GetLastSectionNumber() + 1)){
		// ZNVω(OH)
		m_TableArray[dwIndex].wSectionNum = (WORD)pSection->GetLastSectionNumber() + 1;
		m_TableArray[dwIndex].SectionArray.resize(m_TableArray[dwIndex].wSectionNum);
		}

	// ZNVf[^XV
	m_TableArray[dwIndex].SectionArray[pSection->GetSectionNumber()] = *pSection;

	// XVݒ
	if(pbUpdate)*pbUpdate = bUpdate;

	return true;
}

const WORD CPsiTable::GetExtensionNum(void) const
{
	// e[u̐Ԃ
	return m_TableArray.size();
}

const bool CPsiTable::GetExtension(const WORD wIndex, WORD *pwExtension) const
{
	if(wIndex >= GetExtensionNum())return false;

	// e[uIDgԂ
	*pwExtension = m_TableArray[wIndex].wTableIdExtension;

	return true;
}

const bool CPsiTable::GetSectionNum(const WORD wIndex, WORD *pwSectionNum) const
{
	if(wIndex >= GetExtensionNum())return false;

	// e[uIDgԂ
	*pwSectionNum = m_TableArray[wIndex].wSectionNum;

	return true;
}

const BYTE CPsiTable::GetVersionNo(const WORD wIndex) const
{
	if(wIndex >= GetExtensionNum())return false;

	return m_TableArray[wIndex].byVersionNo;
}

const CMediaData * CPsiTable::GetSectionData(const WORD wIndex, const BYTE bySectionNo) const
{
	if(wIndex >= GetExtensionNum())return NULL;
	if(bySectionNo > m_TableArray[wIndex].wSectionNum)return NULL;

	// ZNVf[^Ԃ
	return &m_TableArray[wIndex].SectionArray[bySectionNo];
}

const CMediaData * CPsiTable::GetSectionDataEx(const WORD wTableIdExtension, const BYTE bySectionNo) const
{
	// e[uIDg
	DWORD dwIndex;

	for(dwIndex = 0 ; dwIndex < m_TableArray.size() ; dwIndex++){
		if(m_TableArray[dwIndex].wTableIdExtension == wTableIdExtension)break;
		}

	if(dwIndex >= GetExtensionNum())return NULL;
	if(bySectionNo > m_TableArray[dwIndex].wSectionNum)return NULL;

	// ZNVf[^Ԃ
	return &m_TableArray[dwIndex].SectionArray[bySectionNo];
}

void CPsiTable::Reset(void)
{
	// SẴe[u폜
	m_TableArray.clear();
}


/////////////////////////////////////////////////////////////////////////////
// PSIe[uZbgۉNX
/////////////////////////////////////////////////////////////////////////////

CPsiTableSuite::CPsiTableSuite()
	: m_bTargetSectionExt(true)
{
	m_PsiSectionParser.SetRecvCallback(m_bTargetSectionExt, CPsiTableSuite::StoreSection, this);

	Reset();
}

CPsiTableSuite::CPsiTableSuite(const CPsiTableSuite &Operand)
{
	*this = Operand;
}

CPsiTableSuite & CPsiTableSuite::operator = (const CPsiTableSuite &Operand)
{
	m_TableSet = Operand.m_TableSet;
	m_bTargetSectionExt = Operand.m_bTargetSectionExt;
	m_bTableUpdated = Operand.m_bTableUpdated;
	m_PsiSectionParser = Operand.m_PsiSectionParser;
	
	m_PsiSectionParser.SetRecvCallback(m_bTargetSectionExt, CPsiTableSuite::StoreSection, this);

	return *this;
}

const bool CPsiTableSuite::StorePacket(const CTsPacket *pPacket)
{
	m_bTableUpdated = false;
	
	// PSIZNVe[uɒǉ
	m_PsiSectionParser.StorePacket(pPacket);

	return m_bTableUpdated;
}

void CPsiTableSuite::SetTargetSectionExt(const bool bTargetExt)
{
	// ΏۂƂZNV̎ނݒ肷(g or W)
	m_bTargetSectionExt = bTargetExt;
	m_PsiSectionParser.SetRecvCallback(bTargetExt, CPsiTableSuite::StoreSection, this);
}

const bool CPsiTableSuite::AddTable(const BYTE byTableID)
{
	const WORD wNum = m_TableSet.size();

	// ID`FbN
	if(GetIndexByID(byTableID) < wNum)return false;

	// Ōɗvfǉ
	m_TableSet.resize(wNum + 1);

	// IDZbg
	m_TableSet[wNum].byTableID = byTableID;

	return true;
}

const WORD CPsiTableSuite::GetIndexByID(const BYTE byTableID)
{
	// ̃e[uID
	for(WORD wIndex = 0 ; wIndex < m_TableSet.size() ; wIndex++){
		if(m_TableSet[wIndex].byTableID == byTableID)return wIndex;
		}

	// G[͏Ƀe[u̍ő吔傫CfbNXԂ
	return 0x0100;
}

const CPsiTable * CPsiTableSuite::GetTable(const WORD wIndex) const
{
	// e[uԂ
	return (wIndex < m_TableSet.size())? &m_TableSet[wIndex].PsiTable : NULL;
}

const CMediaData * CPsiTableSuite::GetSectionData(const WORD wIndex, const WORD wSubIndex, const BYTE bySectionNo) const
{
	// ZNVf[^Ԃ
	const CPsiTable *pPsiTable = GetTable(wIndex);

	// e[uȂ
	if(!pPsiTable)return NULL;

	// f[^Ԃ
	return pPsiTable->GetSectionData(wSubIndex, bySectionNo);
}

const CMediaData * CPsiTableSuite::GetSectionDataEx(const WORD wIndex, const WORD wTableIdExtension, const BYTE bySectionNo) const
{
	// ZNVf[^Ԃ
	const CPsiTable *pPsiTable = GetTable(wIndex);

	// e[uȂ
	if(!pPsiTable)return NULL;

	// f[^Ԃ
	return pPsiTable->GetSectionDataEx(wTableIdExtension, bySectionNo);
}

void CPsiTableSuite::Reset(void)
{
	m_bTableUpdated = false;

	m_PsiSectionParser.Reset();
	m_TableSet.clear();
}

const WORD CPsiTableSuite::GetTableIdExtension(void) const
{
	// e[uIDgԂ
	return m_PsiSectionParser.GetTableIdExtension();
}

const DWORD CPsiTableSuite::GetCrcErrorCount(void) const
{
	return m_PsiSectionParser.GetCrcErrorCount();
}

void CALLBACK CPsiTableSuite::StoreSection(const CPsiSection *pSection, const PVOID pParam)
{
	CPsiTableSuite *pThis = static_cast<CPsiTableSuite *>(pParam);

	// ΏۊÕZNV͏Ȃ
	if(pSection->IsExtendedSection() != pThis->m_bTargetSectionExt) {
		return;
	}

	// e[uID
	const WORD wIndex = pThis->GetIndexByID(pSection->GetTableID());

	// e[uIDȂ
	if(wIndex >= pThis->m_TableSet.size()) {
		return;
	}

	// e[uɃXgA
	bool bUpdate = false;
	pThis->m_TableSet[wIndex].PsiTable.StoreSection(pSection, &bUpdate);

	if(bUpdate) {
		pThis->m_bTableUpdated = true;
	}
	else {
	}
}


/////////////////////////////////////////////////////////////////////////////
// PATe[uۉNX
/////////////////////////////////////////////////////////////////////////////

CPatTable::CPatTable()
	: CPsiTableSuite()
{
	Reset();
}

const bool CPatTable::StorePacket(const CTsPacket *pPacket)
{
	if(CPsiTableSuite::StorePacket(pPacket)){
		// e[uXVꂽ̂ŉ͂
		const CMediaData *pData = GetSectionDataEx(GetIndexByID(0x00),GetTableIdExtension());
		if(pData){
			if(!ParseTable(pData->GetData(), (WORD)pData->GetSize())){
				// e[uɃG[
				Reset();
				}
			}
		
		return true;
		}

	return false;
}

const bool CPatTable::IsNitPacket(const CTsPacket *pPacket)
{
	// ͂ꂽpPbgNIT̃pPbgǂԂ
	for(WORD wIndex = 0 ; wIndex < m_NitPIDArray.size() ; wIndex++){
		if(pPacket->m_Header.wPID == m_NitPIDArray[wIndex].wPID)return true;		
		}

	return false;
}

const bool CPatTable::IsPmtPacket(const CTsPacket *pPacket)
{
	// ͂ꂽpPbgPMT̃pPbgǂԂ
	for(WORD wIndex = 0 ; wIndex < m_PmtPIDArray.size() ; wIndex++){
		if(pPacket->m_Header.wPID == m_PmtPIDArray[wIndex].wPID)return true;		
		}

	return false;
}

const WORD CPatTable::GetNitPID(const WORD wIndex) const
{
	// NITPIDԂ
	return (wIndex < m_NitPIDArray.size())? m_NitPIDArray[wIndex].wPID : 0xFFFF;	// 0xFFFF͖`PID
}

const WORD CPatTable::GetNitNum(void) const
{
	// NIT̐Ԃ
	return m_NitPIDArray.size();
}

const WORD CPatTable::GetPmtProgramID(const WORD wIndex) const
{
	// PMTPIDԂ
	return (wIndex < m_PmtPIDArray.size())? m_PmtPIDArray[wIndex].wProgramID : 0xFFFF;	// 0xFFFF͖`PID
}

const WORD CPatTable::GetPmtPID(const WORD wIndex) const
{
	// PMTPIDԂ
	return (wIndex < m_PmtPIDArray.size())? m_PmtPIDArray[wIndex].wPID : 0xFFFF;	// 0xFFFF͖`PID
}

const WORD CPatTable::GetPmtNum(void) const
{
	// PMT̐Ԃ
	return m_PmtPIDArray.size();
}

void CPatTable::Reset(void)
{
	// ԂNA
	CPsiTableSuite::Reset();

	m_NitPIDArray.clear();
	m_PmtPIDArray.clear();

	SetTargetSectionExt(true);	// PAT͊gPSIZNV
	AddTable(0x00);				// PAT̃e[uID0x00
}

const bool CPatTable::ParseTable(const BYTE *pHexData, const WORD wDataSize)
{
	if(wDataSize % 4)return false;	// e[ũTCYs

	// PIDNA
	m_NitPIDArray.clear();
	m_PmtPIDArray.clear();

	TAG_PATITEM PatItem;

	// e[u͂

	TRACE(TEXT("\n------- PAT Table -------\n"));

	for(WORD wPos = 0 ; wPos < wDataSize ; wPos += 4, pHexData += 4){
		PatItem.wProgramID	= ((WORD)pHexData[0] << 8) | (WORD)pHexData[1];				// +1,2
		PatItem.wPID		= ((WORD)(pHexData[2] & 0x1F) << 8) | (WORD)pHexData[3];	// +3,4

		if(!PatItem.wProgramID){
			// NITPID
			TRACE(TEXT("NIT #%u [ID:%04X][PID:%04X]\n"), m_NitPIDArray.size(), PatItem.wProgramID, PatItem.wPID);
			m_NitPIDArray.push_back(PatItem);
			}
		else{
			// PMTPID
			TRACE(TEXT("PMT #%u [ID:%04X][PID:%04X]\n"), m_PmtPIDArray.size(), PatItem.wProgramID, PatItem.wPID);
			m_PmtPIDArray.push_back(PatItem);
			}
		}

	return true;
}


/////////////////////////////////////////////////////////////////////////////
// PMTe[uۉNX
/////////////////////////////////////////////////////////////////////////////

CPmtTable::CPmtTable()
	: CPsiTableSuite()
{
	Reset();
}

CPmtTable::CPmtTable(const CPmtTable &Operand)
{
	*this = Operand;
}

CPmtTable & CPmtTable::operator = (const CPmtTable &Operand)
{
	CPsiTableSuite::operator = (Operand);
	m_wPcrPID = Operand.m_wPcrPID;
	m_CaMethodDesc = Operand.m_CaMethodDesc;
	m_EsInfoArray = Operand.m_EsInfoArray;
	
	return *this;
}

const bool CPmtTable::StorePacket(const CTsPacket *pPacket)
{
	if(CPsiTableSuite::StorePacket(pPacket)){
		// e[uXVꂽ̂ŉ͂
		//const CMediaData *pData = GetSectionData();
		const CMediaData *pData = GetSectionDataEx(GetIndexByID(0x02),GetTableIdExtension());
		if(pData){
			if(!ParseTable(pData->GetData(), (WORD)pData->GetSize())){
				// e[uɃG[
				Reset();
				}
			}
		
		return true;
		}

	return false;
}

const WORD CPmtTable::GetPcrPID(void) const
{
	// PCR_PID Ԃ
	return m_wPcrPID;
}

const CCaMethodDesc * CPmtTable::GetCaMethodDesc(void) const
{
	// Conditional Access Method Descriptor Ԃ
	return &m_CaMethodDesc;
}

const WORD CPmtTable::GetEsInfoNum(void) const
{
	// ES̐Ԃ
	return m_EsInfoArray.size();
}

const BYTE CPmtTable::GetStreamTypeID(const WORD wIndex) const
{
	// Stream Type ID Ԃ
	return (wIndex < m_EsInfoArray.size())? m_EsInfoArray[wIndex].byStreamTypeID : 0x00;	// 0x00͖`ID
}

const WORD CPmtTable::GetEsPID(const WORD wIndex) const
{
	// Elementary Stream PID Ԃ
	return (wIndex < m_EsInfoArray.size())? m_EsInfoArray[wIndex].wEsPID : 0xFFFF;			// 0xFFFF͖`PID
}

const CStreamIdDesc * CPmtTable::GetStreamIdDesc(const WORD wIndex) const
{
	// Stream ID Descriptor Ԃ
	return (wIndex < m_EsInfoArray.size())? &m_EsInfoArray[wIndex].m_StreamIdDesc : NULL;
}

const CHierarchicalDesc * CPmtTable::GetHierarchicalDesc(const WORD wIndex) const
{
	// Stream ID Descriptor Ԃ
	return (wIndex < m_EsInfoArray.size())? &m_EsInfoArray[wIndex].m_HierarchicalDesc : NULL;
}

const CCaMethodDesc * CPmtTable::GetCaMethodDesc(const WORD wIndex) const
{
	// Stream ID Descriptor Ԃ
	return (wIndex < m_EsInfoArray.size())? &m_EsInfoArray[wIndex].m_CaMethodDesc : NULL;
}

const bool CPmtTable::IsEsPID(const WORD wPID) const
{
	// nꂽPIDg̔ԑgɑ邩Ԃ
	for(WORD wIndex = 0 ; wIndex < m_EsInfoArray.size() ; wIndex++){
		if(wPID == m_EsInfoArray[wIndex].wEsPID){
			return true;
			}
		}

	return false;
}

void CPmtTable::Reset(void)
{
	// ԂNA
	CPsiTableSuite::Reset();

	SetTargetSectionExt(true);	// PMT͊gPSIZNV
	AddTable(0x02);				// PMT̃e[uID0x02

	m_wPcrPID = 0xFFFF;
	m_CaMethodDesc.Reset();
	m_EsInfoArray.clear();
}

const bool CPmtTable::ParseTable(const BYTE *pHexData, const WORD wDataSize)
{
	// ԂNA
	m_wPcrPID = 0xFFFF;
	m_CaMethodDesc.Reset();
	m_EsInfoArray.clear();

	// e[u͂
	WORD wDescLen = ((WORD)(pHexData[2] & 0x0F) << 8) | (WORD)pHexData[3];
	m_wPcrPID = ((WORD)(pHexData[0] & 0x1F) << 8) | (WORD)pHexData[1];				// +0,1
	WORD wDescPos = 4;
	WORD wDescLenRemainder = wDescLen;
	while(wDescPos < (4 + wDescLen)) {
		m_CaMethodDesc.ParseDesc(&pHexData[wDescPos], (BYTE)wDescLenRemainder);							// +4
		wDescLenRemainder -= (2 + pHexData[wDescPos + 1]);
		wDescPos += (2 + pHexData[wDescPos + 1]);
	}

	char szECM[20];
	szECM[0] = 0x00;
	if(m_CaMethodDesc.IsValid()) {
		if(m_CaMethodDesc.GetCaPID() != 0xFFFF)
			sprintf(szECM,"ECM PID = %04X\n",m_CaMethodDesc.GetCaPID());
	}

	// Xg[̊JnʒuvZ
	WORD wPos = wDescLen + 4;
	TAG_PMTITEM PmtItem;

	TRACE(TEXT("\n------- PMT Table -------\nPCR PID = %04X\n%s"), m_wPcrPID, szECM);

	// Xg[
	while(wPos < wDataSize){
		PmtItem.byStreamTypeID = pHexData[wPos + 0];													// +0
		PmtItem.wEsPID = ((WORD)(pHexData[wPos + 1] & 0x1F) << 8) | (WORD)pHexData[wPos + 2];			// +1,2	
		wDescLen = ((WORD)(pHexData[wPos + 3] & 0x0F) << 8) | (WORD)pHexData[wPos + 4];					// +3,4

		// Xg[IDLqq(ȂH)
		WORD wDescPos = wPos + 5;
		WORD wDescLenRemainder = wDescLen;
		bool bRes;
		while(wDescPos < (wPos + 5 + wDescLen)) {
			bRes = PmtItem.m_StreamIdDesc.ParseDesc(&pHexData[wDescPos], (BYTE)wDescLenRemainder);					// +5
			if(!bRes)
				bRes = PmtItem.m_HierarchicalDesc.ParseDesc(&pHexData[wDescPos], (BYTE)wDescLenRemainder);			// +5
			if(!bRes)
				bRes = PmtItem.m_CaMethodDesc.ParseDesc(&pHexData[wDescPos], (BYTE)wDescLenRemainder);			// +5
			wDescLenRemainder -= (2 + pHexData[wDescPos + 1]);
			wDescPos += (2 + pHexData[wDescPos + 1]);
		}

		szECM[0] = 0x00;
		if(PmtItem.m_CaMethodDesc.IsValid()) {
			if(m_CaMethodDesc.GetCaPID() != PmtItem.m_CaMethodDesc.GetCaPID() && PmtItem.m_CaMethodDesc.GetCaPID() < 0x1FFF)
				sprintf(szECM," ECM PID = %04X",PmtItem.m_CaMethodDesc.GetCaPID());
		}
		TRACE(TEXT("[%u] Stream Type ID = %02X  PID = %04X%s\n"), m_EsInfoArray.size(), PmtItem.byStreamTypeID, PmtItem.wEsPID,szECM);		

		// e[uɒǉ
		m_EsInfoArray.push_back(PmtItem);
		wPos += (wDescLen + 5);
		}

	return true;
}


